/*
     File:       CarbonCore/CarbonCore.h
 
     Contains:   Master include for CarbonCore private framework
 
     Copyright:  © 1999-2011 by Apple Inc. All rights reserved.
 
     Bugs?:      For bug reports, consult the following page on
                 the World Wide Web:
 
                     http://developer.apple.com/bugreporter/
 
*/
#ifndef __CARBONCORE__
#define __CARBONCORE__

#ifndef __COREFOUNDATION__
#include <CoreFoundation/CoreFoundation.h>
#endif


#ifndef __CONDITIONALMACROS__
#include <ConditionalMacros.h>
#endif

#ifndef __MACTYPES__
#include <MacTypes.h>
#endif

#ifndef __FINDER__
#include <CarbonCore/Finder.h>
#endif

#ifndef __FIXMATH__
#include <CarbonCore/FixMath.h>
#endif

#ifndef __SCRIPT__
#include <CarbonCore/Script.h>
#endif

#ifndef __UTCUTILS__
#include <CarbonCore/UTCUtils.h>
#endif

#ifndef __TEXTCOMMON__
#include <CarbonCore/TextCommon.h>
#endif

#ifndef __COLLECTIONS__
#include <CarbonCore/Collections.h>
#endif

#ifndef __ENDIAN__
#include <CarbonCore/Endian.h>
#endif

#ifndef __GESTALT__
#include <CarbonCore/Gestalt.h>
#endif

#ifndef __MACMEMORY__
#include <CarbonCore/MacMemory.h>
#endif

#ifndef __MATH64__
#include <CarbonCore/Math64.h>
#endif

#ifndef __MIXEDMODE__
#include <CarbonCore/MixedMode.h>
#endif

#ifndef __MACERRORS__
#include <CarbonCore/MacErrors.h>
#endif

#ifndef __BACKUPCORE__
#include <CarbonCore/BackupCore.h>
#endif

#ifndef __DISKSPACERECOVERY__
#include <CarbonCore/DiskSpaceRecovery.h>
#endif

#ifndef __COMPONENTS__
#include <CarbonCore/Components.h>
#endif

#ifndef __OSUTILS__
#include <CarbonCore/OSUtils.h>
#endif

#ifndef __FILES__
#include <CarbonCore/Files.h>
#endif

#ifndef __RESOURCES__
#include <CarbonCore/Resources.h>
#endif

#ifndef __CODEFRAGMENTS__
#include <CarbonCore/CodeFragments.h>
#endif

#ifndef __ALIASES__
#include <CarbonCore/Aliases.h>
#endif

#ifndef __MACLOCALES__
#include <CarbonCore/MacLocales.h>
#endif

#ifndef __DEBUGGING__
#include <CarbonCore/Debugging.h>
#endif

#ifndef __PLSTRINGFUNCS__
#include <CarbonCore/PLStringFuncs.h>
#endif

#ifndef __DRIVERSYNCHRONIZATION__
#include <CarbonCore/DriverSynchronization.h>
#endif

#ifndef __DRIVERSERVICES__
#include <CarbonCore/DriverServices.h>
#endif

#ifndef __INTLRESOURCES__
#include <CarbonCore/IntlResources.h>
#endif

#ifndef __NUMBERFORMATTING__
#include <CarbonCore/NumberFormatting.h>
#endif

#ifndef __DATETIMEUTILS__
#include <CarbonCore/DateTimeUtils.h>
#endif

#ifndef __STRINGCOMPARE__
#include <CarbonCore/StringCompare.h>
#endif

#ifndef __TEXTUTILS__
#include <CarbonCore/TextUtils.h>
#endif

#ifndef __TOOLUTILS__
#include <CarbonCore/ToolUtils.h>
#endif

#ifndef __UNICODEUTILITIES__
#include <CarbonCore/UnicodeUtilities.h>
#endif

#ifndef __FP__
#include <CarbonCore/fp.h>
#endif

#include <fenv.h>
#ifndef __TEXTENCODINGCONVERTER__
#include <CarbonCore/TextEncodingConverter.h>
#endif

#ifndef __UNICODECONVERTER__
#include <CarbonCore/UnicodeConverter.h>
#endif

#ifndef __THREADS__
#include <CarbonCore/Threads.h>
#endif

#ifndef __FOLDERS__
#include <CarbonCore/Folders.h>
#endif

#ifndef __TIMER__
#include <CarbonCore/Timer.h>
#endif

#ifndef __MULTIPROCESSINGINFO__
#include <CarbonCore/MultiprocessingInfo.h>
#endif

#ifndef __MULTIPROCESSING__
#include <CarbonCore/Multiprocessing.h>
#endif

#ifndef __MACHINEEXCEPTIONS__
#include <CarbonCore/MachineExceptions.h>
#endif

#ifndef __LOWMEM__
#include <CarbonCore/LowMem.h>
#endif

#ifndef __AVLTREE__
#include <CarbonCore/AVLTree.h>
#endif

#ifndef __PEFBINARYFORMAT__
#include <CarbonCore/PEFBinaryFormat.h>
#endif

#ifndef __HFSVOLUMES__
#include <CarbonCore/HFSVolumes.h>
#endif

#ifndef __AIFF__
#include <CarbonCore/AIFF.h>
#endif

#ifndef __TEXTENCODINGPLUGIN__
#include <CarbonCore/TextEncodingPlugin.h>
#endif


#endif /* __CARBONCORE__ */

